/* ====================================================================
 * The Apache Software License, Version 1.1
 *
 * Copyright (c) 2000-2003 Justin Kirby
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by the
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "Apache" and "Apache Software Foundation" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache",
 *    nor may "Apache" appear in their name, without prior written
 *    permission of the Apache Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 */
#include "oapr/oapr.hpp"
#include "oapr/oapr_buildconfig.hpp"
#include "oapr/oapr_app.hpp"
#include "oapr/oapr_exc_base.hpp"
#include "oapr/oapr_exc_utils.hpp"
#include <string>
#include <list>
#include <iostream>

FILE_VERSION("$Revision: 1.4.2.1 $",oapr_exc_utils_cpp);

using namespace std;

/**\todo add stream as arg so we can send to wherever*/
void oapr::print_stack(std::ostream*const ostrm,const exception_base& eb)
{
  exception_base::exc_cont::const_iterator pos = eb.begin();
  for(; pos != eb.end(); ++pos) {
    (*ostrm) << pos->file() << ":" << pos->line() << "-"
	     << pos->source() << ":" << pos->method() << ":"
	     << pos->level() << "-" << pos->what() << endl;
  }
  (*ostrm) << eb.file() << ":" << eb.line() << "-"
	   << eb.source() << ":"<< eb.method() << ":"
	   << eb.level() << "-"<< eb.what() << endl;
}

void oapr::namespace_from_pretty_function(const string& pretty_function, string& out)
{
  string::size_type p = pretty_function.rfind("::");
  if(p != string::npos && p>1)
  {
    string::size_type p2 = pretty_function.rfind("::", p-1);
    if(p2 == string::npos) p2 = 1; else p2 += 2;
    out = pretty_function.substr(p2, p-p2);
  }
  else
    out.clear();
  //**\todo check cases in which out is "" - perhaps clear step can be omitted. (tired) */
  if(out.empty()) out = oapr_app::name();
}

